#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

vi *str_to_vi(string &s) {
	int n = sz(s);
	vi *out = new vi(n);
	rep(i, 0, n) {
		(*out)[i] = (int) s[i] - (int) 'a';
	}
	return out;
}

int find_after(vi *char_pos, int min_pos, int max_pos) {
	auto iter = lower_bound(all(*char_pos), min_pos);
	if(iter == char_pos->end()) return max_pos;
	return *iter;
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin.exceptions(cin.failbit);

	int n, k; cin >> n >> k;
	string s; cin >> s;
	int q; cin >> q;

	vi *base = str_to_vi(s);

	vector<vi *> char_pos(k);
	vector<int> char_pos_i(k);
	rep(i, 0, k) {
		char_pos[i] = new vi(n, n);
		char_pos_i[i] = 0;
	}
	
	rep(i, 0, n) {
		(*char_pos[ (*base)[i] ])[ char_pos_i[ (*base)[i] ] ] = i;
		char_pos_i[ (*base)[i] ] += 1;
	}

	vi dp(n+1);
	int fill = 0;
	vi status(k, 0);
	dp[n] = 1;
	for(int pos = n-1; pos >= 0; --pos) {
		int curr = (*base)[pos];
		if(!status[curr]) {
			status[curr] = 1;
			fill = fill + 1;
		}
		if(fill == k) {
			status = vi(k, 0);
			fill = 0;
			dp[pos] = 1;
		}
	}
	delete base;

	for(int i = n-1; i >= 0; --i) {
		dp[i] = dp[i] + dp[i+1];
	}

	rep(test, 0, q) {
		string t; cin >> t;
		vi *query = str_to_vi(t);

		int pos = -1;
		for(int c : *query) {
			pos = find_after(char_pos[c], pos+1, n);
		}
		delete query;

		if(pos == n) cout << 0;
		else cout << dp[pos+1];
		cout << '\n';
	}

	rep(i, 0, k) delete char_pos[i];
	return 0;
}

